'-- register JSDrop.DropInfo as a "Shell helper object" so that Explorer will load it at startup.
' The way this works:
' This step is not necessary for a normal drop handler. If you register for HTAs, for instance, the dropped
' file will turn up in the HTA object's commandLine property when the HTA loads. But if you want to be
' notified of file drops through the DropInfo event this step is necessary. It causes JSDrop.DropInfo to be loaded
' at startup by Explorer. At that point DropInfo puts itself into the Running Object Table (ROT). What this means
' is that the object is available using GetObject(, "JSDrop.DropInfo"). The DropInfo event FileDrop can then be used by
' any script or software.  (See the hook demo.vbs script.)     

' In plain language:
 '    If you don't care about using the DropInfo object to get drop events, skip this.
 '    If you want to use DropInfo it must get loaded. There are two ways to do that: 1) Drop a file onto a file type registered for JSDrop. 2) Have it load at startup by using this script.

'-- This method will put the DropInfo object into the Registry key:
'     HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\ShellServiceObjectDelayLoad
'  This will only work on 2000/XP. Microsoft broke the functionality starting with Vista. It is still possible to
'  add to the ROT in Vista/7 but it requires that the drop handler be called at least once by the system.
'  To do that you can manually drop a file onto any file type you have registered for JSDrop. Explorer will
'  then call JSDrop and that gives JSDrop a chance to put itself into the ROT.

Dim DH, Ret, BooROT, sErr
BooROT = MsgBox("Click Yes to add JSDrop to the Running Object Table at startup. Click No to remove the setting.", 35, "JSDrop")
  If BooROT = 2 Then WScript.Quit
  
Set DH = CreateObject("JSDrop.Setup")
  If BooROT = 6 Then
     Ret = DH.RegisterForROT()  
  Else
     Ret = DH.UnregisterForROT()  
  End If
 
  If Ret = 0 Then
     MsgBox "Operation succeeded."
  Else
     sErr = DH.ErrorString(Ret)
     MsgBox "Error " & Ret & ": " & sErr 
  End If   
     
Set DH = Nothing  

'-- if this script fails it will probably be a permissions issue.
