'-- This script demonstrates access to the JSDrop.DropInfo instance that runs in
'-- the ROT, which allows any subscribing script or software to be informed when
'-- a relevant file is dropped onto. 
'-- For the demo, register at least 1 file type with JSDrop, then run this script.
'-- Nothing will happen. The script is looping. Next, drop a file onto a registered type.

'-- Example: If you set up JSDrop to handle .hta files then run this script and then
'-- drop a file onto a .hta file. (You should see the mouse cursor turn into a shortcut
'-- arrow as you "enter the space" of the target file.) You should see a MsgBox showing 
'-- the file extension (hta) and the 2 file paths. The script will then quit with a msgbox 
'-- saying "Done". If this script does not work that way then either the target file extension
'-- is not set up to use JSDrop as a drop handler, or JSDrop.DropInfo is not loaded in
'-- the ROT.

Dim DI, DH, BooRun
BooRun = True

On Error Resume Next
 Set DI = GetObject(, "JSDrop.DropInfo")
 On Error GoTo 0  

 '-- this shouldn't be an issue, at least on 2000/XP, if the RegisterForROT function has been used.
If IsObject(DI) = False Then
  MsgBox "Error. JSDrop.DropInfo object is not in the ROT."
  WScript.Quit
End If

  '-- this allows the script to get the FileDrop event from the JSDrop.DropInfo instance running in the ROT.
WScript.ConnectObject DI, "DI_"

  '-- keep the script alive while waiting for the event.
Do While BooRun = True
  WScript.sleep 100
Loop

' Getting to here means the event has fired. So clean up and quit.

WScript.DisconnectObject DI
MsgBox "Done."
WScript.Quit

Sub DI_FileDrop(TargetExtension, TargetFile, DropFile, CancelRun)
  BooRun = False
  CancelRun = True  '--comment this line to run HTA. If Cancel = True it will prevent the file from being run.
  MsgBox TargetExtension & vbCrLf & TargetFile & vbCrLf & DropFile    
End Sub


